# -*- encoding: utf-8 -*-
###########################################################################
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

{
    "name" : "Report Account Aged Partner Balance view for SISB",
    "version" : "1.0",
    "author" : "Vauxoo ¬ Industrias Diana",
    "category" : "Sales & Purchases Report",
    "description" : """This module inherits a sql view for Account Aged Partner Balance today to be adapted to SISB.""",
    "website" : "http://www.industriasdiana.gob.ve",
    "license" : "AGPL-3",
    "depends" : ["account_aged_partner_balance_vw"],
    "init_xml" : [],
    "demo_xml" : [],
    "update_xml" : [
        "security/account_aged_partner_balance_vw_security.xml",
        'security/ir.model.access.csv',
        "account_aged_partner_balance_vw_wizard_s.xml",
        "sisb_account_aged_partner_balance_vw_view.xml",
        'sisb_board_account_view.xml',
        "report/sisb_aged_partner_report.xml",
        "report/sisb_aged_partner_report_s.xml",
    ],
    "installable" : True,
    "active" : False,
}
