#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://openerp.com.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Humberto Arocha <hbto@vauxoo.com>     
#    Planified by: Humberto Arocha / Nhomar Hernandez
#    Audited by: Vauxoo C.A.
#    Adapted and Modified by: Industrias Diana, C.A.
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
################################################################################

{
    "name" : "Retenciones Municipales",
    "version" : "0.1",
    "author" : "Industrias Diana, C.A.",
    "category" : "Generic Modules",
    "website": "http://www.industriasdiana.gob.ve",
    "description": '''Administración de la Aplicacion de Retenciones Municipales''',
    "depends" : [
                "base",
                "account",
                "l10n_ve_withholding",
                ],
    "init_xml" : [],
    "demo_xml" : [

    ], 
    "update_xml" : [
        'security/wh_muni_security.xml',
        'security/ir.model.access.csv',
        'view/wh_muni_view.xml',
        'view/account_invoice_view.xml',
        'view/company_view.xml',
        'model/wizard_wh_muni_view.xml',
        'workflow/l10n_ve_wh_muni_wf.xml',
        'data/data.xml',
        'wh_muni_report.xml',
    ],
    "active": False,
    "installable": True
}
