# -*- encoding: utf-8 -*-
##############################################################################
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

{
    "name" : "Transferencias Bancarias",
    "version" : "0.1",
    "depends" : ["account_voucher", "bank_management"],
    "author" : "Industrias Diana, C.A.",
    "description" : """
        Modulo para el manejo de transacciones bancarias
    """,
    "website" : "http://www.industriasdiana.gob.ve",
    "category" : "Banking/Accounting",
    "init_xml" : [
    ],
    "update_xml" : [
        'data/txt_transferencia_data.xml',
        'view/account_bank.xml',
        'view/account_bank_statement_config.xml',
        'view/account_bank_statement_line.xml',
        'pago_sequence.xml',
        'view/banking_view.xml',
        'wizard/cobranza_en_linea.xml',
        'security/security_account_bank_statement.xml',
        'security/ir.model.access.csv',
    ],
    "active": False,
    "installable": True,
}
