#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta


class report_albaranes(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(report_albaranes, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_data': self._get_data,

                    })
        self.context= context


    def _get_data(self,form):

	data=[]
	partner_id = form['partner_id']
	product_id = form['product_id']
	category_id = form['category_id']
	date_from = form['date_from']
	date_to = form['date_to']
	state = form['state']
	type_alb = form['type']
	location_id = form['location_id']
	location_dest_id = form['location_dest_id']
	
	if partner_id:
	    if location_dest_id:
		if product_id and not state:
		    self.cr.execute("""
			select distinct a.name as referencia,'['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			inner join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			inner join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id
			where a.partner_id='%s' and a.type='%s' and c.product_id='%s' and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
			and c.location_dest_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(partner_id,type_alb,product_id,date_from,date_to,location_id,location_dest_id))
		elif product_id and state:
		    self.cr.execute("""
			select distinct a.name as referencia,'['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			inner join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			inner join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id
			where a.partner_id='%s' and a.state='%s' and a.type='%s' and c.product_id='%s' and (c.date  BETWEEN '%s' AND '%s') and a.state='%s'
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
			and c.location_dest_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(partner_id,state,type_alb,product_id,date_from,date_to,location_id,location_dest_id))
		elif category_id and not state:
		    self.cr.execute("""
			select distinct a.name as referencia, a.type as tipo, '['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			inner join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			inner join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.partner_id='%s' and a.type='%s' 
			and (c.date  BETWEEN '%s' AND '%s') 
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
			and c.location_dest_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
			and g.categ_id
			in (
			select distinct slh.id as child_id from product_category slp
			left outer join product_category slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(partner_id,type_alb,date_from,date_to,location_id,location_dest_id,category_id))
		elif category_id and state:
		    self.cr.execute("""
			select distinct a.name as referencia, a.type as tipo, '['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			inner join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			inner join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.partner_id='%s' and a.type='%s' 
			and (c.date  BETWEEN '%s' AND '%s') and a.state='%s'
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
			and c.location_dest_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
			and g.categ_id
			in (
			select distinct slh.id as child_id from product_category slp
			left outer join product_category slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(partner_id,type_alb,date_from,date_to,state,location_id,location_dest_id,category_id))
	    else:
		if product_id and not state:
		    self.cr.execute("""
			select distinct a.name as referencia,'['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			inner join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			inner join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			where a.partner_id='%s' and a.type='%s' and c.product_id='%s' and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(partner_id,type_alb,product_id,date_from,date_to,location_id))
		elif product_id and state:
		    self.cr.execute("""
			select distinct a.name as referencia,'['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			inner join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			inner join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.partner_id='%s' and a.state='%s' and a.type='%s' and c.product_id='%s' and (c.date  BETWEEN '%s' AND '%s') and a.state='%s'
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(partner_id,state,type_alb,product_id,date_from,date_to,location_id))
		elif category_id and not state:
		    self.cr.execute("""
			select distinct a.name as referencia, a.type as tipo, '['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			inner join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			inner join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			where a.partner_id='%s' and a.type='%s' 
			and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
			and g.categ_id
			in (
			select distinct slh.id as child_id from product_category slp
			left outer join product_category slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(partner_id,type_alb,date_from,date_to,location_id,category_id))
		elif category_id and state:
		    self.cr.execute("""
			select distinct a.name as referencia, a.type as tipo, '['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			inner join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			inner join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.partner_id='%s' and a.type='%s' 
			and (c.date  BETWEEN '%s' AND '%s') and a.state='%s'
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
			and g.categ_id
			in (
			select distinct slh.id as child_id from product_category slp
			left outer join product_category slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(partner_id,type_alb,date_from,date_to,state,location_id,category_id))
	else:
	    if location_dest_id:
		if product_id and not state:
		    self.cr.execute("""
			select distinct a.name as referencia,'['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			left outer join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			left outer join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.type='%s' and c.product_id='%s' and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
			and c.location_dest_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(type_alb,product_id,date_from,date_to,location_id,location_dest_id))
		elif product_id and state:
		    self.cr.execute("""
			select distinct a.name as referencia,'['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			left outer join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			left outer join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.state='%s' and a.type='%s' and c.product_id='%s' and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
			and c.location_dest_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(state,type_alb,product_id,date_from,date_to,location_id,location_dest_id))
		elif category_id and not state:
		    self.cr.execute("""
			select distinct a.name as referencia, a.type as tipo, '['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			left outer join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			left outer join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.type='%s' 
			and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
			and c.location_dest_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
			and g.categ_id
			in (
			select distinct slh.id as child_id from product_category slp
			left outer join product_category slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(type_alb,date_from,date_to,location_id,location_dest_id,category_id))
		elif category_id and state:
		    self.cr.execute("""
			select distinct a.name as referencia, a.type as tipo, '['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			left outer join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			left outer join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.type='%s' 
			and (c.date  BETWEEN '%s' AND '%s') and a.state='%s'
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
			and c.location_dest_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
			and g.categ_id
			in (
			select distinct slh.id as child_id from product_category slp
			left outer join product_category slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(type_alb,date_from,date_to,state,location_id,location_dest_id,category_id))
	    else:
		if product_id and not state:
		    self.cr.execute("""
			select distinct a.name as referencia,'['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			left outer join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			left outer join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.type='%s' and c.product_id='%s' and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)			
		    """%(type_alb,product_id,date_from,date_to,location_id))
		elif product_id and state:
		    self.cr.execute("""
			select distinct a.name as referencia,'['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			left outer join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			left outer join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.state='%s' and a.type='%s' and c.product_id='%s' and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(state,type_alb,product_id,date_from,date_to,location_id))
		elif category_id and not state:
		    self.cr.execute("""
			select distinct a.name as referencia, a.type as tipo, '['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			left outer join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			left outer join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.type='%s' 
			and (c.date  BETWEEN '%s' AND '%s')
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
			and g.categ_id
			in (
			select distinct slh.id as child_id from product_category slp
			left outer join product_category slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(type_alb,date_from,date_to,location_id,category_id))
		elif category_id and state:
		    self.cr.execute("""
			select distinct a.name as referencia, a.type as tipo, '['||d.default_code||']'||' '||d.name_template as producto, a.type as tipo, h.name as categoria,
			c.product_qty as cantidad,e.name as unidad,round(c.price_unit,2) as precio_unitario,round(cast(g.weight as numeric),2) as peso_bruto,round(cast(g.weight_net as numeric),2) as peso_neto,
			a.state as estado,i.name as origen,j.name as destino,a.date_done as fecha_realizado,f.name||' '||b.name||' '||b.street as direccion
			from stock_picking as a
			left outer join res_partner_address b on b.id = a.address_id
			inner join stock_move c on c.picking_id=a.id
			inner join product_product d on d.id=c.product_id
			inner join product_uom e on e.id=c.product_uom
			left outer join res_partner f on f.id=a.partner_id
			inner join product_template g on d.product_tmpl_id = g.id
			inner join product_category h on g.categ_id=h.id
			inner join stock_location i on c.location_id=i.id
			inner join stock_location j on c.location_dest_id=j.id			
			where a.type='%s' 
			and (c.date  BETWEEN '%s' AND '%s') and a.state='%s'
			and c.location_id
			in (
			select distinct slh.id as child_id from stock_location slp
			left outer join stock_location slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
			and g.categ_id
			in (
			select distinct slh.id as child_id from product_category slp
			left outer join product_category slh on slh.parent_left between slp.parent_left and slp.parent_right
			where slp.id = '%s' order by slh.id
			)
		    """%(type_alb,date_from,date_to,state,location_id,category_id))
        data = self.cr.dictfetchall()
        return data

  
report_sxw.report_sxw('report.report.albaranes',
                    'stock.picking',
                    'sisb_fix_report_albaranes/report/report_albaranes.rml',
                    parser= report_albaranes,
                    )
