#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) Industrias Diana, C.A. (<http://www.industriasdiana.gob.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Industrias Diana, C.A.          
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
################################################################################

from osv import fields, osv
import time
from tools.translate import _
import decimal_precision as dp

class islr_wh_doc(osv.osv):
    _inherit = "islr.wh.doc"
    _name="islr.wh.doc"
    
    def action_process(self,cr,uid,ids, *args):
        """Se sobrescribio la funcion para agregar
        la validacion de no aprobar si no existen lineas"""
        obj_brw = self.browse(cr, uid, ids)
        if obj_brw[0].concept_ids:
            self.write(cr,uid,ids,{'state':'progress'})
            return True
        else:
            raise osv.except_osv(_('Warning'),_('The document has no retention lines!, Please review the document'))
            return False
        
islr_wh_doc()


