#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) Industrias Diana, C.A. (<http://www.industriasdiana.gob.ve>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Industrias Diana, C.A.          
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
################################################################################

from osv import fields, osv
import time
from tools.translate import _
import decimal_precision as dp

class account_wh_iva(osv.osv):
    _inherit = "account.wh.iva"
    _name = "account.wh.iva"
    """Se sobreescribe el check_vat_wh, esta
    funcion es llamada desde el workflow para
    verificar si existen lineas antes de confirmar
    la rentencion"""
    def check_vat_wh(self, cr, uid, ids, context={}):
        if self.browse(cr, uid, ids[0]).wh_lines:
            return super(account_wh_iva, self).check_vat_wh(cr, uid, ids, context)
        else:
            raise osv.except_osv(_('Warning'),_('The document has no retention lines!, Please review the document'))
            return False

account_wh_iva()
