#########################################################################
#                                                                       #
# Copyright (C) 2009  Sharoon Thomas                                    #
#                                                                       #
#This program is free software: you can redistribute it and/or modify   #
#it under the terms of the GNU General Public License as published by   #
#the Free Software Foundation, either version 3 of the License, or      #
#(at your option) any later version.                                    #
#                                                                       #
#This program is distributed in the hope that it will be useful,        #
#but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#GNU General Public License for more details.                           #
#                                                                       #
#You should have received a copy of the GNU General Public License      #
#along with this program.  If not, see <http://www.gnu.org/licenses/>.  #
#########################################################################
from osv import osv,fields

class hr_employee(osv.osv):
    _inherit="hr.employee"
    _columns = {
        'is_driver':fields.boolean('Driver'),
        'license_no':fields.char('License No',size=25),
        'issued_from':fields.char('Issuing Authority',size=100),
        'date_of_expiry':fields.date('Expiry Date'),
        'license_class': fields.many2one('fms.parameters', 'License class', domain="[('type','=','lcsclass')]"),
        #'expiry_event':fields.many2one('fms.calendar','Expiration record on calendar')
                }
    _defaults={
        'is_driver':lambda *a: False,
               }
hr_employee()
