# -*- coding: utf-8 -*-


import time
from report import report_sxw


class diana_account_invoice(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(diana_account_invoice, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'total': self.total,
            'pendiente': self.pendiente,
            
        })
    
    def total(self, obj):
        mont = 0
        for pay in obj:
            mont += pay.amount_total
        return mont
        
    def pendiente(self, obj):
        mont = 0
        for pay in obj:
            mont += pay.residual
        return mont
        
    
report_sxw.report_sxw(
    'report.diana.account.invoice',
    'account.invoice',
    'addons/diana_report_account/report/diana_account_print_invoice.rml',
    parser=diana_account_invoice
)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
