# -*- encoding: utf-8 -*-
##############################################################################
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

{
    "name" : "Presupuesto Publico",
    "version" : "0.2",
    "depends" : ["purchase", "stock", "account_voucher", "diana_almacenes", 
        "sisb_purchase_management","l10n_ve_withholding_iva","l10n_ve_withholding_islr",
        "sisb_merge_purchase_requisition","bank_management", "sisb_ventas"],
    "author" : "Industrias Diana, C.A.",
    "description" : """
        Modulo para el manejo del presupuesto publico en Venezuela.
        Este modulo esta compuesto por:
        
        * Clasificador presupuestario.
        * Imputaciones en compra y venta.
    """,
    "website" : "http://www.industriasdiana.gob.ve",
    "category" : "Presupuesto/Accounting",
    "init_xml" : [
    ],
    "update_xml" : [
        'security/presupuesto_security.xml',
        'security/ir.model.access.csv',
        'view/l10n_ve_presupuesto.xml',
        'view/l10n_ve_clasificador.xml',
        'view/l10n_ve_boar_presupuesto.xml',
        'view/product.xml',
        'view/periodo_presupuestario.xml',
        'view/accion_especifica.xml',
        'view/vistas_heredadas.xml',
        'view/formulacion.xml',
        'wizard/wizard_meses_accion_centralizada.xml',
        'wizard/wizard_meses_accion_especifica.xml',
        'wizard/presupuesto_clasificador_list.xml',
        'wizard/wizard_check.xml',
        'report/l10n_ve_presupuesto_imputacion_graph.xml',
        'report/reporte_financiero_mensual.xml',
    ],
    "active": False,
    "installable": True,
    "external_dependencies": {
       "python": ["xlwt",],
       }
}
