# -*- coding: utf-8 -*-
from osv import osv
from osv import fields
import netsvc

class sale_shop(osv.osv):
    _inherit = 'sale.shop'

    _columns = {
        'partida_id': fields.many2one('clasificador.presupuestario','Partida'),
        'accion_especifica_id': fields.many2one('accion.especifica', 'Accion Especifica'),
    }
    

sale_shop()

class sale_order_line(osv.osv):
    _name = 'sale.order.line'
    _inherit = 'sale.order.line'
    
    def product_id_change(self, cr, uid, ids, pricelist, product, qty=0,
        uom=False, qty_uos=0, uos=False, name='', partner_id=False, 
        lang=False, update_tax=True, date_order=False, packaging=False, fiscal_position=False, flag=False, shop_id=False, esdadiva=False):
    
        res = super(sale_order_line, self).product_id_change(cr, uid, ids, pricelist, product, qty,
            uom, qty_uos, uos, name, partner_id,
            lang, update_tax, date_order, packaging, fiscal_position, flag)

        sale_sh = self.pool.get("sale.shop")
        if shop_id:
            sale_sh_brw = sale_sh.browse(cr, uid, [shop_id])
        else:
            return res
        
        partida = False
        accion = False
        for shop in sale_sh_brw:
            partida = shop.partida_id and shop.partida_id.id or None
            accion = shop.accion_especifica_id and shop.accion_especifica_id.id or None
        if esdadiva:
            res["value"].update({'partida_presupuesto':partida, 'accion_especifica_id':accion})
        else:
            res["value"].update({'accion_especifica_id':accion})
        return res
    
sale_order_line()
