#!/usr/bin/python	
# -*- encoding: utf-8 -*-	
###############Credits#########################################################	
#    Finance by: Industrias Diana, C.A. http://www.industriasdiana.gob.ve	
###############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################

from osv import osv
from osv import fields
import sys
from tools.translate import _
import time


class report_bank_reconciliation(osv.osv_memory):
    
    _name = "report.bank.reconciliation"
    _description = "Report Bank Reconciliation"

    _columns = {
	'acc_number': fields.many2one('res.partner.bank','Bank Account'),	
        }


    def report_bank_reconciliation(self, cr, uid, ids, data, context=None):
	if context is None:
            context = {}
        data['form'] = self.read(cr, uid, ids,['acc_number'])[0]
	return {'type': 'ir.actions.report.xml', 'report_name': 'report.bank.reconciliation', 'datas': data}

	    
report_bank_reconciliation()
