#-*- coding:utf-8 -*-
##############################################################################
#
#    SISB, Sistema Integral Simón Bolivar
#    Copyright (C) 2012-2013 Industrias Diana, C.A. All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
{
    'name': 'Sisb Nomina',
    'version': '1.0',
    'category': 'Human Resources',
    "sequence": 38,
    'complexity': "normal",
    'description': """ """,
    'author':'Industrias Diana C.A.',
    'website':'http://www.industriasdiana.gob.ve',
    'depends': [
        'account_voucher',
        'hr',
        'hr_contract',
        'hr_holidays',
        'decimal_precision',
    ],
    'init_xml': [
    ],
    'update_xml': [
        'security/hr_security.xml',
        'wizard/hr_payroll_payslips_by_employees.xml',        
        'view/hr_payroll_view.xml',
        'view/sisb_nomina_view.xml',
        'view/hr_shift_rotation_view.xml',
        'view/hr_shift_rotation_cron_view.xml',
        #~ 'hr_complete_payslip_workflow.xml',
        'view/hr_payroll_workflow.xml',
        'view/hr_payroll_sequence.xml',
        'view/hr_payroll_report.xml',
        'view/bono_alimentacion_xls_view.xml',
        'view/pago_nomina_txt_view.xml',
        'security/ir.model.access.csv',
        'wizard/hr_payroll_contribution_register_report.xml',
        'wizard/hr_make_period_view.xml',
        'wizard/hr_salary_increase_view.xml',
        'wizard/prestaciones_employee_view.xml',
        'data/hr_holidays_data.xml',
        'view/hr_paid_order_view.xml',
        'report/report_process_concepts.xml',
        'report/report_process_payslips.xml',
        'report/report_liquidacion_vacaciones.xml',
        'report/report_payslip_line_view.xml',
        'view/hr_end_contract_cron.xml',
        'wizard/hr_salary_increase_history_view.xml',
        'report/hr_listado_conceptos.xml',
        'report/hr_conceptos.xml',
        'wizard/guarderia_invoice_view.xml',
        'view/sisb_liquidaciones_view.xml',
        'report/propuesta_liquidacion_view.xml',
        'report/hr_constancia_trabajo.xml',
    ],
    'test': [
    #'test/payslip.yml',
#         'test/payment_advice.yml',
#         'test/payroll_register.yml',
        # 'test/hr_payroll_report.yml',
    ],
    'active' : False,
    'installable' : True,
    'data' : [],
    'external_dependencies': {
       'python': ['xlwt',],
    },
}

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
