#-*- coding:utf-8 -*-

import netsvc
import time
from tools.translate import _
from osv import fields, osv
import datetime


class hr_listado_conceptos(osv.osv_memory):
    _name = 'hr.listado.conceptos'
    _description = 'Creacion listado de conceptos'

    _columns = {
        'month_id': fields.many2one('hr.month', 'Mes', required=True),
        'payroll_id': fields.many2one('hr.payroll', 'Nomina'),
        'concept_id': fields.many2one('hr.concept', "Concepto"),
    }
    
    def hr_listado_conceptos(self, cr, uid, ids, context=None):
        data = {
            'ids': context.get('active_ids', []),
            'model': 'hr.process',
            'form': self.read(cr, uid, ids, [], context = context )[0]
        }
        paid_brw = self.browse(cr, uid, ids)[0]
        data['form']['month_id'] = paid_brw.month_id.id
        data['form']['payroll_id'] = paid_brw.payroll_id.id
        data['form']['concept_id'] = paid_brw.concept_id.id
        data['form']['hr_ids'] = context.get('active_ids')
        return {'type': 'ir.actions.report.xml', 'report_name': 'hr.listado.conceptos', 'datas': data}

        

hr_listado_conceptos()
