#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta
import datetime as dt


class solicitud(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(solicitud, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_empresa':self.get_empresa,
            'get_nota':self.get_nota,
           
                    })
        self.context= context
        

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
    def get_nota(self, origin):
        obj_addr = self.pool.get('diana.stock.procurement')
        obj_preq = self.pool.get('purchase.requisition')
        
        addr_id =obj_addr.search(self.cr, self.uid, [('name','=',origin)])
        
        while(addr_id==[] and origin):
            addr_id=obj_preq.search(self.cr, self.uid, [('name','=',origin)])
            origin= obj_preq.read(self.cr, self.uid, addr_id, ['origin'])[0]['origin'] or ''
            addr_id=obj_addr.search(self.cr, self.uid, [('name','=',origin)])
            
        global_notes = obj_addr.read(self.cr, self.uid, addr_id, ['global_notes'])[0]['global_notes'] or ''
        return global_notes

report_sxw.report_sxw('report.purchase.requisition.solicitud',
                    'purchase.requisition',
                     parser= solicitud,
                    #~ header= 'internal',
                    rml= 'sisb_purchase_management/report/solicitud.rml'
                    )
