# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
#~ 
from osv import osv
from osv import fields
import sys
from tools.translate import _
import time
#~

class requisition_report_status_wizard(osv.osv_memory):
    _name = "requisition.report.status.wizard"
    _description = "requisition report status wizard."

    _columns = {
        'date_from': fields.date("Start Date", required=True),
        'date_to': fields.date("End Date", required=True),
        }
    _defaults = {
        'date_from': lambda *a: time.strftime('%Y-%m-%d'),
        'date_to': lambda *a: time.strftime('%Y-%m-%d'),
 
        }

    def report_wizard_requisicion(self, cr, uid, ids, data, context=None):
        data['form'] = self.read(cr, uid, ids,['date_from','date_to'])[0]
        return {'type': 'ir.actions.report.xml', 'report_name': 'requisition.report.status.wizard', 'datas': data}
        

  

requisition_report_status_wizard()


