from report import report_sxw
from numero_a_texto import Numero_a_Texto

class traspasos(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(traspasos, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'numero_en_letras': self.obt_texto,
            'get_empresa':self.get_empresa,
        })
        self.context = context

    def obt_texto(self, amount):
        return  Numero_a_Texto(str(amount))

    def get_salesman_code(self, user_id):
        emp_obj = self.pool.get('hr.employee')
        employee_id = emp_obj.search(cr, uid, [('user_id', '=', user_id)])
        return semp_obj.browse(cr, uid, employee_id).user_id or ''
        
    
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        

report_sxw.report_sxw(
    'report.sisb.traspasos.sucursales',
    'traspasos',
    'sisb_traspasos_sucursales/report/traspasos.rml',
    parser=traspasos, header=False
)
