from report import report_sxw
from numero_a_texto import Numero_a_Texto

class rep_invoice(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(rep_invoice, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'sum_qty':self.sum_qty,
            'numero_en_letras': self.obt_texto,
        })
        self.context = context
        
    def sum_qty(self,invoice_id):
        self.cr.execute("select sum(quantity) from account_invoice_line where invoice_id =%s ", (invoice_id,))
        res = self.cr.fetchone()
        return res[0]

    def obt_texto(self, amount):
        return  Numero_a_Texto(str(amount))

    def get_salesman_code(self, user_id):
        emp_obj = self.pool.get('hr.employee')
        employee_id = emp_obj.search(cr, uid, [('user_id', '=', user_id)])
        return semp_obj.browse(cr, uid, employee_id).user_id or ''

report_sxw.report_sxw(
    'report.sisb.invoice',
    'account.invoice',
    'sisb_ventas/report/invoice.rml',
    parser=rep_invoice, header=False
)
